var IMWB_CC = ( function (win, doc, $) {

   var inCopyFunc,
       useDocSelection = !!(typeof doc['selection'] == 'object' && doc['selection']);
       
   var getSelectionObject = function() {
      var selObj;
      
      if(useDocSelection)
         selObj = doc.selection.createRange(); 
      else
         selObj = win.getSelection();
         
      return selObj;
   }
   
   var getSelectWordsCount = function(selObj) {
      var selWords 
      
      if(useDocSelection)   
         selWords = $.trim(selObj.text).split(/\s+/g).length;
      else 
         selWords = selObj.rangeCount == 0 ? -1 : $.trim(selObj.toString()).split(/\s+/g).length;
      
      return selWords;
   
   }
   
   var isHostMethod = function (obj, method) {
       var t = typeof obj[method];
       return t == 'function' || (!!(t == 'object' && obj[method])) || t == "unknown";
   }
   
   var highlightRange = function(selObj, rngObj) {
   
      if(isHostMethod(selObj, 'setBaseAndExtent'))
         selObj.setBaseAndExtent(rngObj.startContainer, rngObj.startOffset, rngObj.endContainer, rngObj.endOffset);
      else if (isHostMethod(selObj, 'select'))
         selObj.select();
      else if (isHostMethod(selObj, 'addRange'))
         selObj.addRange(rngObj);
   }
       
   var copyEvent = function (event) {

      if (inCopyFunc) return false;
      
      var $clipBuf = $("<div></div>");
      $clipBuf.css({'overflow': 'hidden',
                  'textAlign': 'left',
                  'border': 'none',
                  'position': 'absolute',
                  'top': '-999px',
                  'height': '0px',
                  'width': '0px'});
                  
      // Get the copied test and make sure has minimum number of words
      var selObj = getSelectionObject();         
      var selWords = getSelectWordsCount(selObj);
       
      if(selWords < IMWB_CPY_Options.aMinWords) 
         return;
      
      inCopyFunc = true;
                         
      if(useDocSelection) { // IE 
         var sl = doc.documentElement.scrollLeft;
         var st = doc.documentElement.scrollTop;
      
         if(IMWB_CPY_Options.aPlace == 'A')
            $clipBuf.html(IMWB_CPY_Options.aText+"<br><br>"+ selObj.htmlText);
         else
            $clipBuf.html(selObj.htmlText+"<br><br>"+IMWB_CPY_Options.aText);
         
         $clipBuf.css('left', sl + "px"),
         $clipBuf.css('top', st + "px"),
         
         $('body').prepend($clipBuf);
         
         var txtRng = doc.body.createTextRange();
         txtRng.moveToElementText($clipBuf.get(0));
         txtRng.select();
         
         win.setTimeout(function () {
            $clipBuf.remove();
            highlightRange(selObj);
            doc.documentElement.scrollLeft = sl;
            doc.documentElement.scrollTop = st;
            inCopyFunc = false;
         }, 0);
      
      }                
      else { // Firefox / Chrome / Safari
        
         var rngObj = selObj.getRangeAt(0);
         
         $clipBuf.css('overflow', '');
         $clipBuf.html('<br>');
         $('body').append($clipBuf);   

         var $selBuf = $("<div></div>");
         $selBuf.css('backgroundColor', 'transparent');
         
         if(IMWB_CPY_Options.aPlace == 'A') {
            $selBuf.html(IMWB_CPY_Options.aText+"<br><br>");
            $selBuf.append(rngObj.cloneContents());
         }
         else {
            $selBuf.append(rngObj.cloneContents());
            $selBuf.append("<br><br>"+IMWB_CPY_Options.aText);
         }         
         $clipBuf.append($selBuf);         
         selObj.selectAllChildren($selBuf.get(0));
  
         win.setTimeout(function () {$clipBuf.remove(); highlightRange(selObj, rngObj); inCopyFunc = false; }, 0);
      }
      
      inCopyFunc = false;
      return;
   }
   
   return  {
      init : function () {
         inCopyFunc = false;
         $('body').bind('copy', copyEvent);
      
      }
   }

})(window, document, jQuery);

jQuery(document).ready(function($) {

      IMWB_CC.init();
      
});

